
note
	
	description: "Action that add cut die of element to a list, if not Void"
	author: "David Hollenberg"
	date: "December 18, 2006"

class ADD_CUT_DIE_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	cut_dies: LIST [CONST_RECTANGLE]
			-- List to which to add cut dies

feature -- Modification

	set_cut_dies (a_list: like cut_dies)
			-- Set `cut_dies' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			cut_dies := a_list
		ensure
			cut_dies_set: cut_dies = a_list
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			if an_element.scribe_cut_die /= Void then
				cut_dies.extend (an_element.scribe_cut_die)
			end
		end

end
