
note
	
	description: "Action to take to align selected objects to center %
		%of align target in X"
	author: "David Hollenberg"
	date: "November 16, 2006"

class ALIGN_CENTER_X_ACTION
inherit
	ALIGN_ACTION

feature {NONE} -- Implementation

	compute_center (an_element: RETICLE_VIEW_ELEMENT)
			-- Compute `new_center' for `an_element'.
		local
			x, y: DOUBLE
		do
			x := align_target.center_x
			y := an_element.center_y
			if not grid.is_edge_on_grid (x - an_element.size_x / 2.0) then
				x := x - grid.edge_resolution / 2.0
			end
			new_center.make_xy (x, y)
		end

	compute_move_distance (an_element: RETICLE_VIEW_ELEMENT)
			-- Compute `move_distance' for `an_element'
		local
			x: DOUBLE
		do
			x := new_center.x - an_element.center_x
			move_distance.make_xy (grid.rounded_edge (x), 0.0)
		end

end
