
note
	
	description: "Action to take to align selected objects to center %
		%of align target in Y"
	author: "David Hollenberg"
	date: "November 16, 2006"

class ALIGN_CENTER_Y_ACTION
inherit
	ALIGN_ACTION

feature {NONE} -- Implementation

	compute_center (an_element: RETICLE_VIEW_ELEMENT)
			-- Compute `new_center' for `an_element'.
		local
			x, y: DOUBLE
		do
			x := an_element.center_x
			y := align_target.center_y
			if not grid.is_edge_on_grid (y - an_element.size_y / 2.0) then
				y := y + grid.edge_resolution / 2.0
			end
			new_center.make_xy (x, y)
		end

	compute_move_distance (an_element: RETICLE_VIEW_ELEMENT)
			-- Compute `move_distance' for `an_element'
		local
			y: DOUBLE
		do
			y := new_center.y - an_element.center_y
			move_distance.make_xy (0.0, grid.rounded_edge (y))
		end

end
