
note
	
	description: "Action that deletes view elements that are cuts that are %
		%not present in another cut pattern"
	author: "David Hollenberg"

class DELETE_NOT_IN_PATTERN_CUT_ACTION
inherit
	OTHER_CUT_PATTERN_ACTION

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			if an_element.is_horizontal_cut and then not other_pattern.has_horizontal_cut_at (an_element.field_relative_center_y) or an_element.is_vertical_cut and then not other_pattern.has_vertical_cut_at (an_element.field_relative_center_x) then
				-- Element is a cut that is not present
				-- in `other_pattern'
				an_element.view.delete_cut (an_element)
				an_element.set_is_selected (False)
				an_element.add_to_changed_region
				an_element.add_change (create {CUT_DELETION_CHANGE}.make (an_element))
			else
				an_element.set_selected (an_element.is_selected, True)
			end
		end

end
