
note
	
	description: "Change that moves left or right end and/or %
		%top or bottom end of object , so that it has a different size and position"
	author: "David Hollenberg"

class RESIZE_CHANGE
inherit
	RETICLE_SIMPLE_CHANGE
		rename
			make as simple_make
		export
			{NONE} simple_make
		end

create
	make

feature {NONE} -- Creation

	make (an_element: RETICLE_VIEW_ELEMENT a_change_x, a_change_y: DOUBLE a_left, a_right, a_bottom, a_top: BOOLEAN)
		do
			simple_make (an_element)
			change_x := a_change_x
			change_y := a_change_y
			is_left_resize := a_left
			is_right_resize := a_right
			is_bottom_resize := a_bottom
			is_top_resize := a_top
		end

feature -- Properties

	change_x: DOUBLE
			-- Amount to resize end in X

	change_y: DOUBLE
			-- Amount to resize end in Y

	is_left_resize: BOOLEAN
			-- Should resize move left edge?
			-- Cannot resize both left and right

	is_right_resize: BOOLEAN
			-- Should resize move right edge?
			-- Cannot resize both left and right

	is_bottom_resize: BOOLEAN
			-- Should resize move bottom edge?
			-- Cannot resize both bottom and top

	is_top_resize: BOOLEAN
			-- Should resize move top edge?
			-- Cannot resize both bottom and top

feature -- Operations

	undo
			-- Undo change
		local
			p: POINT
		do
			create p.make_xy (0.0, 0.0)
			if change_x /= 0.0 or change_y /= 0.0 then
				p.make_xy (-change_x, -change_y)
				element.resize_by (p, is_left_resize, is_right_resize, is_bottom_resize, is_top_resize)
			end
		end

	redo
			-- Redo change
		local
			p: POINT
		do
			create p.make_xy (0.0, 0.0)
			if change_x /= 0.0 or change_y /= 0.0 then
				p.make_xy (change_x, change_y)
				element.resize_by (p, is_left_resize, is_right_resize, is_bottom_resize, is_top_resize)
			end
		end

end
