
note
	
	description: "Simple change that is comprised of a list of simple changes"
	author: "David Hollenberg"
	date: "January 25, 2007"

class RETICLE_SIMPLE_CHANGE_LIST
inherit
	RETICLE_SIMPLE_CHANGE
		rename
			make as simple_make
		export
			{NONE} simple_make
		end

create
	make

feature {NONE} -- Creation

	make (an_element: RETICLE_VIEW_ELEMENT a_list: LIST [RETICLE_SIMPLE_CHANGE])
		require
			an_element_not_void: an_element /= Void
			a_list_not_void: a_list /= Void
		do
			simple_make (an_element)
			change_list := a_list
		end

feature -- Properties

	change_list: LIST [RETICLE_SIMPLE_CHANGE]
			-- List of changes that comprise the change

feature -- Operations

	undo
			-- Undo change
		local
			chg: RETICLE_SIMPLE_CHANGE
		do
			from
				change_list.finish
			until
				change_list.before
			loop
				chg := change_list.item
				if parent /= Void then
					chg.set_parent (parent)
				end
				chg.undo
				change_list.back
			end
		end

	redo
			-- Redo change
		local
			chg: RETICLE_SIMPLE_CHANGE
		do
			from
				change_list.start
			until
				change_list.after
			loop
				chg := change_list.item
				if parent /= Void then
					chg.set_parent (parent)
				end
				chg.redo
				change_list.forth
			end
		end

end
