
note
	
	description: "Change that moves one end of a scribe%
		%scribe, so that it has a different size and position"
	author: "David Hollenberg"
	date: "January 25, 2007"

class SCRIBE_END_POSITION_CHANGE
inherit
	RETICLE_SIMPLE_CHANGE
		rename
			make as simple_make
		export
			{NONE} simple_make
		end

create
	make

feature {NONE} -- Creation

	make (an_element: RETICLE_VIEW_ELEMENT a_change_x, a_change_y: DOUBLE a_left_or_bottom: BOOLEAN)
		do
			simple_make (an_element)
			change_x := a_change_x
			change_y := a_change_y
			is_left_or_bottom := a_left_or_bottom
		end

feature -- Properties

	change_x: DOUBLE
			-- Amount to resize end in X

	change_y: DOUBLE
			-- Amount to resize end in Y

	is_left_or_bottom: BOOLEAN
			-- Was position of left or bottom end moved,
			-- rather than right or top end?

feature -- Operations

	undo
			-- Undo change
		local
			p: POINT
		do
			create p.make_xy (0.0, 0.0)
			if change_x /= 0.0 or change_y /= 0.0 then
				p.make_xy (-change_x, -change_y)
				resize_by (p)
			end
		end

	redo
			-- Redo change
		local
			p: POINT
		do
			create p.make_xy (0.0, 0.0)
			if change_x /= 0.0 or change_y /= 0.0 then
				p.make_xy (change_x, change_y)
				resize_by (p)
			end
		end

	resize_by (p: CONST_POINT)
			-- Resize `element' by `p'
		do
			if element.is_horizontal_scribe then
				element.resize_by (p, is_left_or_bottom, not is_left_or_bottom, False, False)
			else
				element.resize_by (p, False, False, is_left_or_bottom, not is_left_or_bottom)
			end
		end

end
