
note
	
	description: "A reticle field of view and the horizontal and %
		%vertical edges of objects that intersect that field"
	author: "David Hollenberg"
	date: "January 17, 2007"

class FIELD_ELEMENT_EDGES
inherit
	GRIDABLE
create
	make

feature {NONE} -- Creation

	make (a: ANY n: INTEGER a_grid: like grid)
			-- Create with space for `n' horizontal and `n'
			-- vertical edges
		do
			grid := a_grid
			create {ARRAYED_LIST [MODEL_ELEMENT_EDGE]} horizontal_edges.make (n)
			create {ARRAYED_LIST [MODEL_ELEMENT_EDGE]} vertical_edges.make (n)
		end

feature -- Properties

	left_limit: DOUBLE
			-- Gridded coordinate of left side of field

	right_limit: DOUBLE
			-- Gridded coordinate of right side of field

	bottom_limit: DOUBLE
			-- Gridded coordinate of bottom side of field

	top_limit: DOUBLE
			-- Gridded coordinate of top side of field

	horizontal_edges: LIST [MODEL_ELEMENT_EDGE]
			-- Horizontal edges of objects that intersect field

	vertical_edges: LIST [MODEL_ELEMENT_EDGE]
			-- Vertical edges of objects that intersect field

feature -- Operations

	sort_edges
			-- Sort `horizontal_edges' and `vertical_edges'
		do
		end

end
