
note
	
	description: "Change applied to reticle during packing that creates %
		%or deletes elements that are abstract dies"
	author: "David Hollenberg"
	date: "January 25, 2007"

deferred class RETICLE_CREATION_OR_DELETION_CHANGE
inherit
	RETICLE_CHANGE
		redefine
			undo_simple_change, redo_simple_change
		end
	
feature -- Operations

	add_fully_deleted_die (a_die: ANY)
		do
		end

	add_deleted_partition (a_partition: ANY)
		do
		end

	add_fully_deleted_element (an_element: RETICLE_VIEW_ELEMENT)
		do
			fully_deleted_elements.extend (an_element)
		end

feature {NONE} -- Implementation

	undo_simple_change (a_change: RETICLE_SIMPLE_CHANGE)
			-- Undo `a_change'
		do
			a_change.set_parent (Current)
			precursor (a_change)
		end

	redo_simple_change (a_change: RETICLE_SIMPLE_CHANGE)
			-- Redo `a_change'
		do
			a_change.set_parent (Current)
			precursor (a_change)
		end

	start_delete
			-- Take actions needed before starting a delete
		do
			view.unmark_all
		end

	finish_delete
			-- Take actions needed after finishing a delete
		do
			if not fully_deleted_elements.is_empty then
				view.update_copies_table_for_delete (fully_deleted_elements)
			end
			view.remove_marked_elements
		end

	fully_deleted_elements: LIST [RETICLE_VIEW_ELEMENT]
			-- Elements for dies whose copies were all deleted

end
