
note
	
	description: "A cut pattern in reticle model"
	author: "David Hollenberg"
	date: "July 28, 2006"

class RETICLE_CUT_PATTERN
inherit
	ANY

create
	make

feature {NONE} -- Creation

	make (a_pattern: ANY a_table: ANY)
		do
		end

feature -- Properties

	is_read_only: BOOLEAN
			-- Is pattern read-only (cannot be modified
			-- or deleted)?
		do
		end

	cut_pattern_no: INTEGER
			-- Number assigned to cut pattern
		do
		end

	production_id: STRING
			-- Production ID cut pattern is for
		do
		end

	cut_pattern_xform_type: STRING
			-- Type of transform cut pattern performs
		do
		end

	cut_pattern_no_parent: INTEGER
			-- Number of parent cut pattern, if not null
		do
		end

	is_null_cut_pattern_no_parent: BOOLEAN
			-- Is parent cut pattern number null?
		do
		end

	source_type: STRING
			-- Type of entity to which cut pattern is applied
		do
		end

	result_type: STRING
			-- Type of entity application of cut
			-- pattern produces
		do
		end

	isolates_sites: BOOLEAN
			-- Does this type of cut pattern
			-- isolate site?
		do
		end

	produces_strips: BOOLEAN
			-- Does this type of cut pattern
			-- produce wafer strips?
		do
		end

	applies_to_strips: BOOLEAN
			-- Is this type of cut pattern
			-- applied to wafer strips?
		do
		end

	presentation_text: STRING
			-- Text that describes current cut pattern
			-- transformation type
		do
		end

	field_name: STRING
			-- Name of field to which cut pattern applies
		do
		end

	has_wafer_etest_name: BOOLEAN
			-- Is there a wafer etest name for cut pattern?
		do
		end

	wafer_etest_name: STRING
			-- Wafer etest name for cut pattern
		do
		end

	wafer_etest_id: STRING
			-- Wafer etest ID for cut pattern
		require
			has_wafer_etest_name: has_wafer_etest_name
		do
		end

	has_quantity_wafers_needed: BOOLEAN
			-- Is there a number wafers to cut for pattern?
		do
		end

	quantity_wafers_needed: INTEGER
			-- Number of wafers to cut for pattern or -1 if
			-- not yet specified
		do
			if has_quantity_wafers_needed then
			else
				Result := -1
			end
		end

	is_completed: BOOLEAN
			-- Is cut pattern completed (not under construction)?
		do
		end

	has_cuts: BOOLEAN
			-- Are there any cuts for pattern?
		do
		end

	has_horizontal_cut_at (a_location: DOUBLE): BOOLEAN
			-- Does pattern include a horizontal cut at
			-- `a_location'?
		do
		end

	has_vertical_cut_at (a_location: DOUBLE): BOOLEAN
			-- Does pattern include a vertical cut at
			-- `a_location'?
		do
		end

	has_isolated_sites: BOOLEAN
			-- Are there any isolated sites for pattern?
		do
		end

	isolates (a_location: ANY): BOOLEAN
			-- Does pattern isolate `a_location'?
		do
		end

	isolated_location_count: INTEGER
			-- Number of die locations isolated by cut pattern
		do
		end

	description: STRING
			-- Description of cut pattern for messages to user
		do
			Result := "Pattern " + cut_pattern_no.out + ", Field " + field_name
		end

	description_for_selection: STRING
			-- Description of cut pattern when it
			-- is included in a list from which user
			-- selects one item
		do
		end

	status: STRING
			-- Status of cut pattern
		do
		end

feature -- Modification

	set_is_completed (a_value: BOOLEAN)
			-- Set `is_completed' to `a_value'
		do
		ensure
			completed_set: is_completed = a_value
		end

	set_cut_pattern_xform_type (a_value: STRING)
			-- Set `cut_pattern_xform_type' to `a_value'
		do
		end

	set_cut_pattern_no_parent (a_value: INTEGER)
			-- Set `cut_pattern_no_parent' to `a_value'
		do
		ensure
			value_set: cut_pattern_no_parent = a_value
		end

	set_null_cut_pattern_no_parent
			-- Set `cut_pattern_no_parent' to null
		do
		ensure
			value_null: is_null_cut_pattern_no_parent
		end

	set_production_id (a_value: STRING)
			-- Set `production_id' to `a_value'
		require
			a_value_not_void: a_value /= Void
			a_value_not_empty: not a_value.is_empty
		do
		ensure
			value_set: production_id.is_equal (a_value)
		end

	set_wafer_etest_name (a_name: STRING)
			-- Set `wafer_etest_name' to `a_name'
		do
		ensure
			name_set: wafer_etest_name.is_equal (a_name)
		end

	set_quantity_wafers_needed (a_value: INTEGER has_value: BOOLEAN)
			-- Set `quantity_wafers_needed' to `a_value' where
			-- `has_value' indicates whether there really is a
			-- value
		do
			if has_value then
			else
			end
		end

feature -- Operations

	remove_isolated_sites
			-- Remove all isolated sites for cut pattern
		do
		end

feature {NONE} -- Implementation

	set_current_xform_type
			-- Set `current_xform_type' row based on 
			-- `cut_pattern_xform_type' value
		do
		end

	update_pattern (an_original, a_replacement: ANY)
			-- If `pattern' equals `an_original', replace it
			-- with `a_replacement'
		do
		end

end
