
note
	
	description: "Actions for view elements"
	author: "David Hollenberg"
	date: "October 1, 2006"

class VIEW_ELEMENT_ACTIONS

feature -- Properties

	align_left_action: ALIGN_ACTION
			-- Action to take to align selected objects to left
			-- side of align target
		once
			create {ALIGN_LEFT_ACTION} Result
		end
	
	align_right_action: ALIGN_ACTION
			-- Action to take to align selected objects to right
			-- side of align target
		once
			create {ALIGN_RIGHT_ACTION} Result
		end
	
	align_top_action: ALIGN_ACTION
			-- Action to take to align selected objects to top
			-- side of align target
		once
			create {ALIGN_TOP_ACTION} Result
		end
	
	align_bottom_action: ALIGN_ACTION
			-- Action to take to align selected objects to bottom
			-- side of align target
		once
			create {ALIGN_BOTTOM_ACTION} Result
		end
	
	align_center_x_action: ALIGN_ACTION
			-- Action to take to align selected objects to center
			-- of align target in X
		once
			create {ALIGN_CENTER_X_ACTION} Result
		end
	
	align_center_y_action: ALIGN_ACTION
			-- Action to take to align selected objects to center
			-- of align target in Y
		once
			create {ALIGN_CENTER_Y_ACTION} Result
		end
	
	move_action: MOVE_ACTION
			-- Action to move all selected elements
		once
			create Result
		end
	
	duplicate_action: DUPLICATE_ACTION
			-- Action to duplicate all selected elements
		once
			create Result
		end
	
	center_in_cut_die_action: CENTER_IN_CUT_DIE_ACTION
			-- Action to center elements that are projects in
			-- their cut die, ignoring projects that are not
			-- isolated in their cut die
		once
			create Result
		end
	
	delete_selected_cut_action: VIEW_ELEMENT_ACTION
			-- Action to delete all selected elements that are cuts
		once
			create {DELETE_SELECTED_CUT_ACTION} Result
		end
	
	delete_intersecting_cut_action: DELETE_INTERSECTING_CUT_ACTION
			-- Action to delete all cuts that intersect the
			-- cut die of any selected project
		once
			create Result
		end
	
	delete_extra_cut_action: VIEW_ELEMENT_ACTION
			-- Action to delete extra cuts (ones that do
			-- not help isolate a site)
		once
			create {DELETE_EXTRA_CUT_ACTION} Result
		end
	
	delete_not_in_pattern_cut_action: DELETE_NOT_IN_PATTERN_CUT_ACTION
			-- Action to delete all cuts in current pattern
			-- that are not present in another cut pattern
		once
			create Result
		end
	
	add_cut_die_action: ADD_CUT_DIE_ACTION
			-- Action to add the cut die to a list, if not Void
		once
			create Result
		end
	
	pre_add_cuts_action: PRE_ADD_CUTS_ACTION
			-- Action to perform before adding cuts through
			-- scribes containing mouse pointer
		once
			create Result
		end
	
	check_scribe_action: VIEW_ELEMENT_ACTION
			-- Action that checks whether a scribe intersects
			-- iat least one field of view and is movable in
			-- its length direction
		once
			create {CHECK_SCRIBE_ACTION} Result
		end
	
	trim_action: TRIM_ACTION
			-- Action that trims a scribe or partition
			-- that intersects at least one field of view
			-- and that has an end that is not in any
			-- field of view by "trimming" that end back
			-- to the field of view edge
		once
			create Result
		end
	
	separate_scribe_action: SEPARATE_SCRIBE_ACTION
			-- Action that replaces a scribe that
			-- intersects more than one field of view with
			-- a set of scribes that represents the
			-- intersection of the scribe with each field
		once
			create Result
		end
	
	extend_action: EXTEND_ACTION
			-- Action that extends both ends of a scribe
			-- or all sides of a partition to the first
			-- meetable edge if not already at a meetable
			-- edge, but without extending a scribe past
			-- an unmeetable edge
		once
			create Result
		end
	
	unoverlap_scribe_action: UNOVERLAP_SCRIBE_ACTION
			-- Action that unoverlaps scribe with all or selected
			-- scribes of opposite orientation that intersect it
		once
			create Result
		end
	
	check_scribe_join_validity_action: VIEW_ELEMENT_ACTION
			-- Action that checks scribe to see if it is valid
			-- to participate in a Join Scribes operation
		once
			create {CHECK_SCRIBE_JOIN_VALIDITY_ACTION} Result
		end
	
	check_partition_join_validity_action: VIEW_ELEMENT_ACTION
			-- Action that checks partition to see if it is valid
			-- to participate in a Join Partitions operation
		once
			create {CHECK_PARTITION_JOIN_VALIDITY_ACTION} Result
		end
	
end
